// 002 u_c_calculator_2
// 18 sep 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_calculator_3;
  interface
    uses Classes, u_i_logable;

    type c_calculator=
              Class(tInterfacedObject, i_logable)
                m_one, m_two: Integer;
                m_result: Integer;

                m_c_stream: tStream;

                procedure add;
                procedure subtract;

                // -- i_log implementation
                procedure initialize_log(p_file_name: String);
                procedure write_to_log(p_message: String);
              end;

  implementation
    uses SysUtils;
    
    // --  c_calculator

    procedure c_calculator.add;
      begin
        write_to_log('add '+ IntToStr(m_one)+ '+ '+ IntToStr(m_two));
      end;

    procedure c_calculator.subtract;
      begin

      end;

    procedure c_calculator.initialize_log(p_file_name: String);
      begin
        m_c_stream:= tFileStream.Create(p_file_name, fmCreate);
      end; // nitialize_log

    procedure c_calculator.write_to_log(p_message: String);
      begin
        m_c_stream.Write(p_message[1], Length(p_message));
      end; // write_to_log

  end.

